﻿define(['durandal/app', 'durandal/system', 'plugins/dialog'], function (app, system, dialog) {
    
    var ctor = function () { };

    ctor.prototype.updateDropDownDataSource = function () {
        var self = this;
        var dataSource1 = [
            { text: "Surname1", value: "value1" },
            { text: "Surname2", value: "value2" },
            { text: "Surname3", value: "value3" },
            { text: "Surname4", value: "value4" },
            { text: "Surname5", value: "value5" }
        ];

         var ddl = $('#' + self.dropDownMultipleId);
         ddl.ejDropDownList("option", "dataSource", dataSource1);
         ddl.ejDropDownList("selectItemByValue", "value1,value3");
    };

    ctor.prototype.activate = function (settings) {
        self = this;
        
        self.dropDownMultipleId = system.guid();

        var ddEnabled = ko.observable(true);

        self.isReadonly = ko.pureComputed(function myfunction() {
            return ddEnabled();
        });

        //DROP DOWNs
        self.dropDownMultiple = {
            dataSource: ko.observableArray([
            { text: "Name1", value: "value1" },
            { text: "Name2", value: "value2" },
            { text: "Name3", value: "value3" },
            { text: "Name4", value: "value4" },
            { text: "Name5", value: "value5" }
        ]),
            fields: { text: "text", value: "value" }, 
            enabled: self.isReadonly,
            allowMultiSelection: true,
            multiSelectMode: "visualMode",
        }

        self.changeButton = {
            contentType: "textonly",
            text: "Change enabled DD",
            click: function () {
                if(ddEnabled()){
                    ddEnabled(false)    
                } else {
                    ddEnabled(true);
                }               
            }
        }

    }

    ctor.prototype.compositionComplete = function () {
        var self = this;

        self.updateDropDownDataSource();
    }

    return ctor;
});